#ifndef __TRAITRATE_UTILS_H
#define __TRAITRATE_UTILS_H
#include "definitions.h"
#include "tree.h"
#include "sequenceContainer.h"
using namespace std;

void checkTreeAndContainerSameTaxa(const tree& et,const sequenceContainer & sc, string inScFileName,  string inTreeFileName, bool bLeavesOnly = true);
void printTreeStatesAsBPValues(ostream &out, Vint &states, const tree::nodeP &myNode, const alphabet* pAlph);
//returns the MP score of the tree assuming 2 character alphabet
int getMPScore(const tree& et,const sequenceContainer & charContainer, int pos); 
//given an unrooted tree - transform to to a rooted one given a model rooted tree
void makeBifurcatingTree(const string& inModelTree, const string& inUnrootedTree, const string& outTree);
//finds in the newTree the MRCA of one of the root sons of modelTree
tree::nodeP findMRCA(const tree& modelTree, const tree& newTree); 
bool containAllNames(const tree& inTree, tree::nodeP fromHere, const vector<tree::nodeP>& leavesToLook);
MDOUBLE getSumTipLengths(const tree& inTree);
//return a new sequence container that contain only the specified codon position (1, 2, or 3) of the input container 
sequenceContainer extractCodonPos(const sequenceContainer& inSc, int pos);

#endif
